/*******************************************************************************
 * FoxWeapon_RocketLauncherBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_RocketLauncherBase extends FoxWeapon_LauncherBase
    abstract
    config(Launcher)
    hidecategories(Navigation);

var const float FireZoomOutDelay;
var export editinline ParticleSystemComponent RocketSightEffect;
var const name RocketBoneName;

simulated function PostBeginPlay()
{
    super(FoxWeapon).PostBeginPlay();
    SkeletalMeshComponent(Mesh).AttachComponent(RocketSightEffect, 'joint1');
    //return;    
}

simulated function FireAmmunition()
{
    SetTimer(FireZoomOutDelay, false, 'TimedUnZoom');
    HideRocket();
    super(FoxWeapon_SemiAutomaticRifleBase).FireAmmunition();
    //return;    
}

simulated function HideRocket()
{
    // End:0xB8
    if((Instigator.IsAliveAndWell() && Instigator.IsLocallyControlled() || IsBeingFPSpectated()) && SkeletalMeshComponent(Mesh).SpaceBases.Length > 0)
    {
        SkeletalMeshComponent(Mesh).HideBoneByName(RocketBoneName, 0);
    }
    //return;    
}

simulated function UnHideRocket()
{
    // End:0xB6
    if((Instigator.IsAliveAndWell() && Instigator.IsLocallyControlled() || IsBeingFPSpectated()) && SkeletalMeshComponent(Mesh).SpaceBases.Length > 0)
    {
        SkeletalMeshComponent(Mesh).UnHideBoneByName(RocketBoneName);
    }
    //return;    
}

simulated function TimedUnZoom()
{
    // End:0x2B
    if(!IsInState('Inactive') && InZoom())
    {
        StepZoom();
    }
    //return;    
}

simulated function StopZoomMode(optional bool bForce)
{
    RocketSightEffect.DeactivateSystem();
    super(FoxWeapon).StopZoomMode();
    //return;    
}

simulated function StartZooming()
{
    // End:0x80
    if(Instigator.IsLocallyControlled() || IsBeingFPSpectated())
    {
        // End:0x61
        if(InZoom())
        {
            RocketSightEffect.ActivateSystem();
        }
        // End:0x80
        else
        {
            RocketSightEffect.DeactivateSystem();
        }
    }
    super(FoxWeapon).StartZooming();
    //return;    
}

function IncrementHits(FoxPawn HitPawn)
{
    local FoxOnlineStatsWriteWeaponUse WriteWeaponUse;

    // End:0x131
    if(!WorldInfo.GRI.OnSameTeam(Instigator, HitPawn) && FoxPawn(Instigator) != none)
    {
        WriteWeaponUse = FoxPawn(Instigator).GetStatsWriteWeaponUse(Class);
        // End:0x131
        if((WriteWeaponUse != none) && bHasHitTarget == false)
        {
            bHasHitTarget = true;
            WriteWeaponUse.IncrementRoundsHit(2);
            // End:0x131
            if(HitPawn.bLastHitWasHeadShot)
            {
                WriteWeaponUse.IncrementHeadshots(2);
            }
        }
    }
    //return;    
}

simulated state Active
{
    simulated function BeginState(name PreviousStateName)
    {
        super.BeginState(PreviousStateName);
        // End:0x2F
        if(!HasAmmo(0))
        {
            HideRocket();
        }
        //return;        
    }
    stop;    
}

simulated state Reloading
{
    simulated function BeginState(name PreviousStateName)
    {
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function bool TryPutDown()
    {
        HideRocket();
        return super.TryPutDown();
        //return ReturnValue;        
    }

Begin:
    Sleep(0.20);
    UnHideRocket();
    stop;        
}

simulated state WeaponEquipping
{
    simulated function BeginState(name PreviousStateName)
    {
        // End:0x1C
        if(!HasAmmo(0))
        {
            HideRocket();
        }
        super.BeginState(PreviousStateName);
        //return;        
    }
    stop;    
}

defaultproperties
{
    FireZoomOutDelay=0.150
    begin object name=MyRocketSightEffect class=FoxFirstPersonParticleSystemComponent
        ReplacementPrimitive=none
        Scale=0.750
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_RocketLauncherBase.MyRocketSightEffect'
    RocketSightEffect=MyRocketSightEffect
    RocketBoneName=RocketLauncher_Rocket
    bIsDepotWeapon=true
    bCanMelee=false
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_RocketLauncherBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_RocketLauncherBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_RocketLauncherBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_RocketLauncherBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.39500110
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_RocketLauncherBase.LensComp'
    MuzzleLensFlare=LensComp
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_RocketLauncherBase.WeaponMesh'
    Mesh=WeaponMesh
}